#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <linux/sched.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>

#define SIM_PORT 10000

void cleanup() {
    system("ip link set sim_br0 down");
    system("brctl delbr sim_br0");
}

int main(int argc, char *argv[]) {
    sleep(1);

    system("brctl addbr sim_br0");
    system("brctl stp sim_br0 off");
//    system("brctl setfd sim_br0 0");

    system("brctl addif sim_br0 sim_client");
    system("ip addr add 9.9.9.2/24 dev sim_br0");
    system("ip link set sim_br0 up");
    system("ip link set sim_client up");

    atexit(cleanup);

    int fd = socket(AF_INET, SOCK_DGRAM, 0);
    if (fd == -1) {
	perror("client socket");
	return 1;
    }
    struct sockaddr_in saddr;
    memset(&saddr, 0, sizeof(saddr));
    saddr.sin_family = AF_INET;
    saddr.sin_port = htons(SIM_PORT);
    inet_aton("9.9.9.2", &saddr.sin_addr);
    if (bind(fd, (struct sockaddr *) &saddr, sizeof(saddr)) < 0) {
	perror("child bind");
	return 1;
    }

    printf("receiving UPD packet\n");
    char buffer[0xffff];
    int ret = recv(fd, buffer, sizeof(buffer) - 1, 0);
    if (ret < 0) {
	perror("recv");
    } else if (ret == 0) {
	printf("recv no data\n");
    } else {
	buffer[ret] = 0;
	printf("recv %s\n", buffer);;
    }
    return 0;
}
